<?php
$tempColumns = [
    'ig_menu_icon' => [
        'exclude' => 0,
        'label' => 'Bild',
        'config' => \TYPO3\CMS\Core\Utility\ExtensionManagementUtility::getFileFieldTCAConfig(
            'ig_menu_icon',
            [
                'appearance' => [
                    'createNewRelationLinkTitle' => 'LLL:EXT:cms/locallang_ttc.xlf:images.addFileReference'
                ],
                'minitems' => 0,
                'maxitems' => 1,
            ],
            $GLOBALS['TYPO3_CONF_VARS']['GFX']['imagefile_ext']
        ),
    ],
    'ig_menu_icon_position' => [
        'label' => 'Position',
        'config' => [
            'type' => 'select',
            'renderType' => 'selectSingle',
            'items' => [
                ['', ''],
                ['Rechts', 'iRight'],
                ['Links', 'iLeft'],
                ['Oben', 'iTop'],
                ['Unten', 'iBottom']
            ],
            'size' => 1,
            'minitems' => 0,
            'maxitems' => 1,
        ]
    ],
    'ig_menu_content_position' => [
        'label' => 'Position',
        'config' => [
            'type' => 'select',
            'renderType' => 'selectSingle',
            'items' => [
                ['', ''],
                ['Content Rechts', 'cRight'],
                ['Content Links', 'cLeft'],
                ['Content Oben', 'cTop'],
                ['Content Unten', 'cBottom']
            ],
            'size' => 1,
            'minitems' => 0,
            'maxitems' => 1,
        ]
    ],
    'ig_menu_content' => [
        'exclude' => 0,
        'label' => 'Elemente',
        'config' => [
            'type' => 'inline',
            'foreign_table' => 'tt_content',
            'foreign_field' => 'ig_menu_content',
            'overrideChildTca' => [
                'columns' => [
                    'colPos' => [
                        'config' => [
                            'default' => '33'
                        ],
                    ],
                    'CType' => [
                        'config' => [
                            'default' => 'textmedia'
                        ],
                    ],
                ],
            ],
            'maxitems' => 999,
            'appearance' => [
                'collapseAll' => 1,
                'levelLinksPosition' => 'top',
                'showSynchronizationLink' => 1,
                'showPossibleLocalizationRecords' => 1,
                'showAllLocalizationLink' => 1
            ],
        ],
    ],


    'ig_menu_source' => [
        'label' => 'Source',
        'config' => [
            'type' => 'select',
            'renderType' => 'selectSingle',
            'items' => [
                ['Default (Unterseiten)', '0'],
                ['Onepager (Seitenlinks auf diese Seite mit #)', '16'],
                //['Database (Subeinträge aus Datenbank)', '101'],
            ],
            'size' => 1,
            'minitems' => 0,
            'maxitems' => 1,
        ]
    ],

    'ig_menu_layout' => [
        'label' => 'Menu Layout',
        'config' => [
            'type' => 'select',
            'renderType' => 'selectSingle',
            'items' => [
                ['Default (Seiten sind Menueinträge)', '0'],
                ['Spalten (Seiten sind Spaltenaufteilungen)', '1'],
                ['2 Spalten (Seiten in zwei Spalten aufteilen)', '2'],
                ['3 Spalten (Seiten in drei Spalten aufteilen)', '3'],
                ['4 Spalten (Seiten in vier Spalten aufteilen)', '4'],
                //                ['Onepage (Seitenlinks auf aktuelle Seite mit #)', '16'],
                //                ['Database (Subeinträge aus Datenbank)', '101'],
            ],
            'size' => 1,
            'minitems' => 0,
            'maxitems' => 1,
        ]
    ],

    'ig_menu_source_options' => [
        'exclude' => 1,
        'displayCond' => 'FIELD:ig_menu_source:REQ:true',
        'label' => 'Source Options',
        'config' => [
            'type' => 'flex',
            'ds_pointerField' => 'ig_menu_source',
            'ds' => [
                'default' => 'FILE:EXT:ig_menu/Configuration/FlexForms/Default.xml',
            ],
        ]
    ],

    'ig_menu_layout_cols' => [
        'displayCond' => 'FIELD:ig_menu_layout:=:1',
        'exclude' => 1,
        'label' => 'Anzahl Spalten',
        'config' => [
            'type' => 'input',
            'size' => 10,
            'eval' => 'int,trim,null',
        ]
    ],


    'ig_menu_col_width' => [
        'displayCond' => 'FIELD:doktype:=:254',
        'label' => 'Spaltenmenus: Spaltenbreite',
        'config' => [
            'type' => 'select',
            'renderType' => 'selectSingle',
            'items' => [
                ['1 Einheit', '1'],
                ['2 Einheiten', '2'],
                ['3 Einheiten', '3'],
                ['4 Einheiten', '4'],
            ],
            'size' => 1,
            'minitems' => 0,
            'maxitems' => 1,
        ]
    ],
    'ig_menu_columns' => [
        'label' => 'Menu Columns',
        'config' => [
            'type' => 'select',
            'renderType' => 'selectSingle',
            'itemsProcFunc' => 'Ig\IgMenu\Backend\Service\IgMenuColumnService->columnsItemsProcFunc',
            'size' => 1,
            'minitems' => 0,
            'maxitems' => 1,
        ]
    ],
    'ig_menu_item_class' => [
        'exclude' => 1,
        'label' => 'Menu Klasse',
        'config' => [
            'type' => 'input',
            'size' => 20,
            'eval' => 'trim',
        ]
    ],

    'ig_menu_replacement_text' => [
        'label' => 'Replacement Text',
        'config' => [
            'type' => 'input',
            'size' => 60,
        ]
    ],
    'ig_menu_is_menuroot' => [
        'exclude' => 0,
        'label' => 'Unterseiten im Hauptmenu verbergen',
        'config' => [
            'type' => 'check',
            'renderType' => 'checkboxToggle',
        ],
    ],



];
\TYPO3\CMS\Core\Utility\ExtensionManagementUtility::addTCAcolumns('pages', $tempColumns);
\TYPO3\CMS\Core\Utility\ExtensionManagementUtility::addFieldsToPalette('pages', 'menu_icons', 'ig_menu_icon,ig_menu_icon_position');
\TYPO3\CMS\Core\Utility\ExtensionManagementUtility::addFieldsToPalette('pages', 'menu_content', 'ig_menu_content,ig_menu_content_position');
\TYPO3\CMS\Core\Utility\ExtensionManagementUtility::addFieldsToPalette('pages', 'menu_layout', 'ig_menu_source,ig_menu_layout,ig_menu_columns');
\TYPO3\CMS\Core\Utility\ExtensionManagementUtility::addFieldsToPalette('pages', 'menu_options', 'ig_menu_source_options,ig_menu_layout_cols,ig_menu_col_width,');
\TYPO3\CMS\Core\Utility\ExtensionManagementUtility::addToAllTCAtypes('pages',
    '--div--;Menu,
    --palette--;Layout;menu_layout,
    --palette--;Layout;menu_options,
    --palette--;Icon;menu_icons,
    --palette--;Inhalt;menu_content,
    ig_menu_replacement_text,ig_menu_item_class',
    '',
    'after:content_from_pid'
);
\TYPO3\CMS\Core\Utility\ExtensionManagementUtility::addFieldsToPalette(
    'pages',
    'visibility',
    'ig_menu_is_menuroot',
    'after:ig_hide_in_sitemap'
);
//ig_menu_source_options,ig_menu_layout_cols,ig_menu_col_width,